#!/usr/bin/env python
"""
An animated image
"""
import matplotlib
import pylab as pl
from matplotlib.backends.backend_gtk import FigureCanvasGTK as FigureCanvas
from matplotlib.figure import Figure
import numpy as np
import common
import random
import time


class AnimatedImage:
    def __init__(self):
        bcnb = common.nBL
        plotnb = 4 #number of graphs
        self.fig = Figure(figsize=(256,256))
        self.fig.subplots_adjust(left=0.04,right=0.99,hspace=0.,wspace=0.,top=0.98,bottom=0.04)
        self.a = {}
        self.b = {}
        self.c = {}
        self.d = {}
        self.lineA1 = {}
        self.lineA2 = {}
        self.lineA3 = {}
        self.lineA4 = {}
        self.lineA11 = {}
        self.lineA12 = {}
        self.lineB1 = {}
        self.lineB2 = {}
        self.lineB3 = {}
        self.lineB4 = {}
        self.lineB11 = {}
        self.lineB12 = {}
        self.lineC1 = {}
        self.lineC2 = {}
        self.lineC3 = {}
        self.lineC4 = {}
        self.lineC11 = {}
        self.lineC12 = {}
        self.lineD1 = {}
        self.lineD2 = {}
        self.lineD3 = {}
        self.lineD4 = {}
        self.lineD11 = {}
        self.lineD12 = {}
        self.uselineA1 = 0
        self.uselineA2 = 0
        self.uselineA3 = 0
        self.uselineA4 = 0
        self.uselineA11 = 0
        self.uselineA12 = 0
        self.uselineB1 = 0
        self.uselineB2 = 0
        self.uselineB3 = 0
        self.uselineB4 = 0
        self.uselineB11 = 0
        self.uselineB12 = 0
        self.uselineC1 = 0
        self.uselineC2 = 0
        self.uselineC3 = 0
        self.uselineC4 = 0
        self.uselineC11 = 0
        self.uselineC12 = 0
        self.uselineD1 = 0
        self.uselineD2 = 0
        self.uselineD3 = 0
        self.uselineD4 = 0
        self.uselineD11 = 0
        self.uselineD12 = 0
        self.Ymin = 0.
        self.Ymax = 0.
        for ndx, i in enumerate(range(1,bcnb+1)):
            self.a[ndx] = (self.fig.add_subplot(plotnb,bcnb,i))
            self.b[ndx] = (self.fig.add_subplot(plotnb,bcnb,i+common.nBL))
            self.c[ndx] = (self.fig.add_subplot(plotnb,bcnb,i+2*common.nBL))
            self.d[ndx] = (self.fig.add_subplot(plotnb,bcnb,i+3*common.nBL))
            #if i==1:
            self.a[ndx].set_xticklabels([])
            self.b[ndx].set_xticklabels([])
            self.c[ndx].set_xticklabels([])
            #if i>1:
            #    self.a[ndx].set_xticklabels([])
            #    self.a[ndx].set_yticklabels([])
            #    self.b[ndx].set_xticklabels([])
            #    self.b[ndx].set_yticklabels([])
            #    self.c[ndx].set_xticklabels([])
            #    self.c[ndx].set_yticklabels([])
            #    self.d[ndx].set_xticklabels([])
            #    self.d[ndx].set_yticklabels([])
        self.canvas = FigureCanvas(self.fig)

    def updateFig(self): 
        if common.liveDisplayStatus:
            for panel in range(4):
                for ndx in range(common.nBL):
                    if common.activeFringe[ndx]:
                        nrLines = 0
                        #if common.plotType[panel] == common.plotEMPTY:
                        #    print "plot empty"
                            
                        if common.plotType[panel] == common.plotFLUXvsOPD:
#                            print "plot Flux-vs-OPD"
                            nrLines = 2
                            arrX1 = np.zeros(common.numberOfFrames, dtype=np.float32)
                            arrX2 = np.zeros(common.numberOfFrames, dtype=np.float32)
                            arrY1 = np.zeros(common.numberOfFrames, dtype=np.float32)
                            arrY2 = np.zeros(common.numberOfFrames, dtype=np.float32)
                            for npxFringe in range(common.numberOfFrames):
                                arrX1[npxFringe] = npxFringe
                                arrX2[npxFringe] = npxFringe
                                arrY1[npxFringe] = common.FLUXvsOPDArr[common.chNrL2Fringe[ndx]][npxFringe]
                                arrY2[npxFringe] = common.FLUXvsOPDArr[common.chNrR2Fringe[ndx]][npxFringe]

                        if common.plotType[panel] == common.plotFTOFFSETSvsT:
                            nrLines = 1
                            arrX1 = np.zeros(common.FTOFFSETSvsTArr.shape[1], dtype=np.float32)
                            arrY1 = np.zeros(common.FTOFFSETSvsTArr.shape[1], dtype=np.float32)
                            for npxScan in range(common.FTOFFSETSvsTArr.shape[1]):
                                arrX1[npxScan] = npxScan
                                arrY1[npxScan] = common.FTOFFSETSvsTArr[ndx][npxScan]
                                

                        if common.plotType[panel] == common.plotDELAYvsT:
#                            print "plot DELAY-vs-T"
                            nrLines = 1
                            arrX1 = np.zeros(common.DELAYvsTArr.shape[1], dtype=np.float32)
                            arrY1 = np.zeros(common.DELAYvsTArr.shape[1], dtype=np.float32)
                            for npxScan in range(common.DELAYvsTArr.shape[1]):
                                arrX1[npxScan] = npxScan
                                arrY1[npxScan] = common.DELAYvsTArr[ndx][npxScan]


                        if common.plotType[panel] == common.plotFTNUMvsT:
                            nrLines = 1
                            arrX1 = np.zeros(common.FTNUMvsTArr.shape[1], dtype=np.float32)
                            arrY1 = np.zeros(common.FTNUMvsTArr.shape[1], dtype=np.float32)
                            for npxScan in range(common.FTNUMvsTArr.shape[1]):
                                arrX1[npxScan] = npxScan
                                arrY1[npxScan] = common.FTNUMvsTArr[ndx][npxScan]


                        if common.plotType[panel] == common.plotPHIvsOPD:
                            nrLines = 1
                            arrX1 = np.zeros(common.numberOfFrames, dtype=np.float64)
                            arrY1 = np.zeros(common.numberOfFrames, dtype=np.float64)
                            for npxFringe in range(common.numberOfFrames):
                                arrX1[npxFringe] = npxFringe
                                arrY1[npxFringe] = common.PHIvsOPDArr[ndx][npxFringe]


                        if common.plotType[panel] == common.plotFTNUMvsFTOFFSETS:
                            nrLines = 1
                            arrX1 = np.zeros(common.FTOFFSETSvsTArr.shape[1], dtype=np.float32)
                            arrY1 = np.zeros(common.FTNUMvsTArr.shape[1], dtype=np.float32)
                            for npxFringe in range(common.numberOfFrames):
                                arrX1[npxFringe] = common.FTOFFSETSvsT[ndx][npxFringe]
                                arrY1[npxFringe] = common.FTNUMvsT[ndx][npxFringe]

                        if common.plotType[panel] == common.plotAMPvsOPD:
                            nrLines = 14
                            count = 0
                            for npxFringe in range(common.numberOfFrames/2):
                                if abs(common.AMPvsOPDArrOPD[ndx][npxFringe]) > 1.E-4:
                                    count += 1

                            if count == 0: count = 1

                            arrX1 = np.zeros(count, dtype=np.float32)
                            arrX2 = np.zeros(count, dtype=np.float32)
                            arrX3 = np.zeros(count, dtype=np.float32)
                            arrX4 = np.zeros(count, dtype=np.float32)
                            arrX11 = 0.
                            arrX12 = 0.
                            arrY1 = np.zeros(count, dtype=np.float32)
                            arrY2 = np.zeros(count, dtype=np.float32)
                            arrY3 = np.zeros(count, dtype=np.float32)
                            arrY4 = np.zeros(count, dtype=np.float32)

                            npxFringe2 = 0
                            for npxFringe in range(common.numberOfFrames/2):
                                if abs(common.AMPvsOPDArrOPD[ndx][npxFringe]) > 1.E-4:
                                    arrX1[npxFringe2] = common.AMPvsOPDArrOPD[ndx][npxFringe]
                                    arrX2[npxFringe2] = common.AMPvsOPDArrOPD[ndx+6][npxFringe]

                                    arrY1[npxFringe2] = common.AMPvsOPDArrFILT[ndx][npxFringe]
                                    arrY2[npxFringe2] = common.AMPvsOPDArrFILT[ndx+6][npxFringe]

#                                    arrY1[npxFringe2] = common.AMPvsOPDArrAMP[ndx][npxFringe]
#                                    arrY2[npxFringe2] = common.AMPvsOPDArrAMP[ndx+6][npxFringe]
                                    
                                    arrY3[npxFringe2] = 0 #common.AMPvsOPDArrAMP[ndx][npxFringe]
                                    arrY4[npxFringe2] = 0 #common.AMPvsOPDArrAMP[ndx+6][npxFringe]

                                    arrX11 = common.AMPvsOPDArrDelays[ndx][1]   #vertical line
                                    arrX12 = common.AMPvsOPDArrDelays[ndx][0]
                                    
                                    npxFringe2 += 1
                                    

                        if common.plotType[panel] == common.plotPHIvsT:
                            nrLines = 1
                            arrX1 = np.zeros(common.PHIvsTArr.shape[1], dtype=np.float32)
                            arrY1 = np.zeros(common.PHIvsTArr.shape[1], dtype=np.float32)
                            for npxScan in range(common.PHIvsTArr.shape[1]):
                                arrX1[npxScan] = npxScan
                                arrY1[npxScan] = common.PHIvsTArr[ndx][npxScan]


                        if common.plotType[panel] == common.plotFLUXvsT:
#                            print "plot Flux-vs-t"
                            nrLines = 2
                            arrX1 = np.zeros(common.FLUXvsTArr.shape[1], dtype=np.float32)
                            arrX2 = np.zeros(common.FLUXvsTArr.shape[1], dtype=np.float32)
                            arrY1 = np.zeros(common.FLUXvsTArr.shape[1], dtype=np.float32)
                            arrY2 = np.zeros(common.FLUXvsTArr.shape[1], dtype=np.float32)
                            for npxScan in range(common.FLUXvsTArr.shape[1]):
                                if ndx == 0:  #B4/B1
                                    ch1 = 0 #L1
                                    ch2 = 1 #R1
                                if ndx == 1:  #B1/B2
                                    ch1 = 2 #L2
                                    ch2 = 3 #R2
                                if ndx == 2:  #B2/B3
                                    ch1 = 4 #L3
                                    ch2 = 5 #R3
                                if ndx == 3:  #B3/B4
                                    ch1 = 6 #L4
                                    ch2 = 7 #R4
                                if ndx == 4:
                                    ch1 = 8 #L5
                                    ch2 = 9 #R5
                                if ndx == 5:
                                    ch1 = 10 #L6
                                    ch2 = 11 #R6
                                
                                arrX1[npxScan] = npxScan
                                arrX2[npxScan] = npxScan
                                arrY1[npxScan] = common.FLUXvsTArr[ch1][npxScan]
                                arrY2[npxScan] = common.FLUXvsTArr[ch2][npxScan]

                        if nrLines == 4 or nrLines == 14:
                            self.Ymin = np.min( [ np.min(arrY1), np.min(arrY2), np.min(arrY3), np.min(arrY4) ] )
                            self.Ymax = np.max( [ np.max(arrY1), np.max(arrY2), np.max(arrY3), np.max(arrY4) ] )

                        #panel A
                        if panel == 0:
                            if common.intPlotA:
                                if nrLines == 0:
                                    if self.uselineA1: self.a[ndx].lines.remove(self.lineA1[ndx])
                                    if self.uselineA2: self.a[ndx].lines.remove(self.lineA2[ndx])
                                    if self.uselineA3: self.a[ndx].lines.remove(self.lineA3[ndx])
                                    if self.uselineA4: self.a[ndx].lines.remove(self.lineA4[ndx])
                                    if self.uselineA11: self.a[ndx].lines.remove(self.lineA11[ndx])
                                    if self.uselineA12: self.a[ndx].lines.remove(self.lineA12[ndx])
                                    if ndx==common.nBL-1:
                                        common.intPlotA = 0
                                        self.uselineA1 = 0
                                        self.uselineA2 = 0
                                        self.uselineA3 = 0
                                        self.uselineA4 = 0
                                        self.uselineA11 = 0
                                        self.uselineA12 = 0
                                if nrLines == 1:
                                    self.lineA1[ndx], = self.a[ndx].plot(arrX1, arrY1, color='black', linewidth=2)
                                    self.uselineA1 = 1
                                    if ndx==common.nBL-1: common.intPlotA = 0
                                if nrLines == 2:
                                    self.lineA1[ndx], = self.a[ndx].plot(arrX1, arrY1, color='red', linewidth=2)
                                    self.lineA2[ndx], = self.a[ndx].plot(arrX2, arrY2, color='blue', linewidth=2)
                                    if ndx==common.nBL-1: common.intPlotA = 0
                                    self.uselineA1 = 1
                                    self.uselineA2 = 1
                                if nrLines == 4:
                                    self.lineA1[ndx], = self.a[ndx].plot(arrX1, arrY1, color='red')
                                    self.lineA2[ndx], = self.a[ndx].plot(arrX2, arrY2, color='blue')
                                    self.lineA3[ndx], = self.a[ndx].plot(arrX3, arrY3, color='orange')
                                    self.lineA4[ndx], = self.a[ndx].plot(arrX4, arrY4, color='green')
                                    if ndx==common.nBL-1: common.intPlotA = 0                            
                                    self.uselineA1 = 1
                                    self.uselineA2 = 1
                                    self.uselineA3 = 1
                                    self.uselineA4 = 1 
                                if nrLines == 14:
                                    self.lineA1[ndx], = self.a[ndx].plot(arrX1, arrY1, color='red', linewidth=2)
                                    self.lineA2[ndx], = self.a[ndx].plot(arrX2, arrY2, color='blue', linewidth=2)
                                    self.lineA3[ndx], = self.a[ndx].plot(arrX1, arrY3, color='red', linestyle='dotted', linewidth=2)
                                    self.lineA4[ndx], = self.a[ndx].plot(arrX2, arrY4, color='blue', linestyle='dotted', linewidth=2)
                                    self.lineA11[ndx], = self.a[ndx].plot([arrX11,arrX11], [self.Ymin,self.Ymax], color='red', linestyle='--', linewidth=2)
                                    self.lineA12[ndx], = self.a[ndx].plot([arrX12,arrX12], [self.Ymin,self.Ymax], color='blue', linestyle='--', linewidth=2)
                                    if ndx==common.nBL-1: common.intPlotA = 0                            
                                    self.uselineA1 = 1
                                    self.uselineA2 = 1
                                    self.uselineA3 = 1
                                    self.uselineA4 = 1
                                    self.uselineA11 = 1
                                    self.uselineA12 = 1
                            else:
                                if nrLines == 1:
                                    self.lineA1[ndx].set_xdata(arrX1)
                                    self.lineA1[ndx].set_ydata(arrY1)
                                if nrLines == 2:
                                    self.lineA1[ndx].set_xdata(arrX1)
                                    self.lineA2[ndx].set_xdata(arrX2)
                                    self.lineA1[ndx].set_ydata(arrY1)
                                    self.lineA2[ndx].set_ydata(arrY2)
                                if nrLines == 4:
                                    self.lineA1[ndx].set_xdata(arrX1)
                                    self.lineA2[ndx].set_xdata(arrX2)
                                    self.lineA3[ndx].set_xdata(arrX3)
                                    self.lineA4[ndx].set_xdata(arrX4)
                                    self.lineA1[ndx].set_ydata(arrY1)
                                    self.lineA2[ndx].set_ydata(arrY2)
                                    self.lineA3[ndx].set_ydata(arrY3)
                                    self.lineA4[ndx].set_ydata(arrY4)
                                if nrLines == 14:
                                    self.lineA1[ndx].set_xdata(arrX1)
                                    self.lineA2[ndx].set_xdata(arrX2)
                                    self.lineA3[ndx].set_xdata(arrX1)
                                    self.lineA4[ndx].set_xdata(arrX2)
                                    self.lineA1[ndx].set_ydata(arrY1)
                                    self.lineA2[ndx].set_ydata(arrY2)
                                    self.lineA3[ndx].set_ydata(arrY3)
                                    self.lineA4[ndx].set_ydata(arrY4)
                                    self.lineA11[ndx].set_xdata([arrX11,arrX11])
                                    self.lineA11[ndx].set_ydata([self.Ymin,self.Ymax])
                                    self.lineA12[ndx].set_xdata([arrX12,arrX12])
                                    self.lineA12[ndx].set_ydata([self.Ymin,self.Ymax])

                                if common.plotType[panel] == common.plotFLUXvsOPD:
                                    self.a[ndx].set_ylim(min([min(arrY1),min(arrY2)]),1.1*max([max(arrY1),max(arrY2)]))
                                else:
                                    if common.plotType[panel] == common.plotAMPvsOPD:
                                        diff=max([max(arrX1),max(arrX2),max(arrX3),max(arrX4)]) - min([min(arrX1),min(arrX2),min(arrX3),min(arrX4)])
                                        self.a[ndx].set_xlim(min([min(arrX1),min(arrX2),min(arrX3),min(arrX4)])-diff*0.05, max([max(arrX1),max(arrX2),max(arrX3),max(arrX4)])+diff*0.05)
                                        diff=max([max(arrY1),max(arrY2),max(arrY3),max(arrY4)]) - min([min(arrY1),min(arrY2),min(arrY3),min(arrY4)])
                                        self.a[ndx].set_ylim(min([min(arrY1),min(arrY2),min(arrY3),min(arrY4)])-diff*0.1, max([max(arrY1),max(arrY2),max(arrY3),max(arrY4)])+diff*0.1)
                                    else:
                                        self.a[ndx].relim()
                                        self.a[ndx].autoscale_view()
                                    

                        #panel B
                        if panel == 1:
                            if common.intPlotB:
                                if nrLines == 0:
                                    if self.uselineB1: self.b[ndx].lines.remove(self.lineB1[ndx])
                                    if self.uselineB2: self.b[ndx].lines.remove(self.lineB2[ndx])
                                    if self.uselineB3: self.b[ndx].lines.remove(self.lineB3[ndx])
                                    if self.uselineB4: self.b[ndx].lines.remove(self.lineB4[ndx])
                                    if self.uselineB11: self.b[ndx].lines.remove(self.lineB11[ndx])
                                    if self.uselineB12: self.b[ndx].lines.remove(self.lineB12[ndx])
                                    if ndx==common.nBL-1:
                                        common.intPlotB = 0
                                        self.uselineB1 = 0
                                        self.uselineB2 = 0
                                        self.uselineB3 = 0
                                        self.uselineB4 = 0
                                        self.uselineB11 = 0
                                        self.uselineB12 = 0
                                if nrLines == 1:
                                    self.lineB1[ndx], = self.b[ndx].plot(arrX1, arrY1, color='black', linewidth=2)
                                    self.uselineB1 = 1
                                    if ndx==common.nBL-1: common.intPlotB = 0
                                if nrLines == 2:
                                    self.lineB1[ndx], = self.b[ndx].plot(arrX1, arrY1, color='red', linewidth=2)
                                    self.lineB2[ndx], = self.b[ndx].plot(arrX2, arrY2, color='blue', linewidth=2)
                                    if ndx==common.nBL-1: common.intPlotB = 0
                                    self.uselineB1 = 1
                                    self.uselineB2 = 1
                                if nrLines == 4:
                                    self.lineB1[ndx], = self.b[ndx].plot(arrX1, arrY1, color='red')
                                    self.lineB2[ndx], = self.b[ndx].plot(arrX2, arrY2, color='blue')
                                    self.lineB3[ndx], = self.b[ndx].plot(arrX3, arrY3, color='orange')
                                    self.lineB4[ndx], = self.b[ndx].plot(arrX4, arrY4, color='green')
                                    if ndx==common.nBL-1: common.intPlotB = 0                            
                                    self.uselineB1 = 1
                                    self.uselineB2 = 1
                                    self.uselineB3 = 1
                                    self.uselineB4 = 1
                                if nrLines == 14:
                                    self.lineB1[ndx], = self.b[ndx].plot(arrX1, arrY1, color='red', linewidth=2)
                                    self.lineB2[ndx], = self.b[ndx].plot(arrX2, arrY2, color='blue', linewidth=2)
                                    self.lineB3[ndx], = self.b[ndx].plot(arrX1, arrY3, color='red', linestyle='dotted', linewidth=2)
                                    self.lineB4[ndx], = self.b[ndx].plot(arrX2, arrY4, color='blue', linestyle='dotted', linewidth=2)
                                    self.lineB11[ndx], = self.b[ndx].plot([arrX11,arrX11], [self.Ymin,self.Ymax], color='red', linestyle='--', linewidth=2)
                                    self.lineB12[ndx], = self.b[ndx].plot([arrX12,arrX12], [self.Ymin,self.Ymax], color='blue', linestyle='--', linewidth=2)
                                    if ndx==common.nBL-1: common.intPlotB = 0                            
                                    self.uselineB1 = 1
                                    self.uselineB2 = 1
                                    self.uselineB3 = 1
                                    self.uselineB4 = 1
                                    self.uselineB11 = 1
                                    self.uselineB12 = 1
                            else:
                                if nrLines == 1:
                                    self.lineB1[ndx].set_xdata(arrX1)
                                    self.lineB1[ndx].set_ydata(arrY1)
                                if nrLines == 2:
                                    self.lineB1[ndx].set_xdata(arrX1)
                                    self.lineB2[ndx].set_xdata(arrX2)
                                    self.lineB1[ndx].set_ydata(arrY1)
                                    self.lineB2[ndx].set_ydata(arrY2)
                                if nrLines == 4:
                                    self.lineB1[ndx].set_xdata(arrX1)
                                    self.lineB2[ndx].set_xdata(arrX2)
                                    self.lineB3[ndx].set_xdata(arrX3)
                                    self.lineB4[ndx].set_xdata(arrX4)
                                    self.lineB1[ndx].set_ydata(arrY1)
                                    self.lineB2[ndx].set_ydata(arrY2)
                                    self.lineB3[ndx].set_ydata(arrY3)
                                    self.lineB4[ndx].set_ydata(arrY4)
                                if nrLines == 14:
                                    self.lineB1[ndx].set_xdata(arrX1)
                                    self.lineB2[ndx].set_xdata(arrX2)
                                    self.lineB3[ndx].set_xdata(arrX1)
                                    self.lineB4[ndx].set_xdata(arrX2)
                                    self.lineB1[ndx].set_ydata(arrY1)
                                    self.lineB2[ndx].set_ydata(arrY2)
                                    self.lineB3[ndx].set_ydata(arrY3)
                                    self.lineB4[ndx].set_ydata(arrY4)
                                    self.lineB11[ndx].set_xdata([arrX11,arrX11])
                                    self.lineB11[ndx].set_ydata([self.Ymin,self.Ymax])
                                    self.lineB12[ndx].set_xdata([arrX12,arrX12])
                                    self.lineB12[ndx].set_ydata([self.Ymin,self.Ymax])
                                    
                                if common.plotType[panel] == common.plotFLUXvsOPD:
                                    self.b[ndx].set_ylim(min([min(arrY1),min(arrY2)]),1.1*max([max(arrY1),max(arrY2)]))
                                else:
                                    if common.plotType[panel] == common.plotAMPvsOPD:
                                        diff=max([max(arrX1),max(arrX2),max(arrX3),max(arrX4)]) - min([min(arrX1),min(arrX2),min(arrX3),min(arrX4)])
                                        self.b[ndx].set_xlim(min([min(arrX1),min(arrX2),min(arrX3),min(arrX4)])-diff*0.05, max([max(arrX1),max(arrX2),max(arrX3),max(arrX4)])+diff*0.05)
                                        diff=max([max(arrY1),max(arrY2),max(arrY3),max(arrY4)]) - min([min(arrY1),min(arrY2),min(arrY3),min(arrY4)])
                                        self.b[ndx].set_ylim(min([min(arrY1),min(arrY2),min(arrY3),min(arrY4)])-diff*0.1, max([max(arrY1),max(arrY2),max(arrY3),max(arrY4)])+diff*0.1)
                                    else:
                                        self.b[ndx].relim()
                                        self.b[ndx].autoscale_view()

                        #panel C
                        if panel == 2:
                            if common.intPlotC:
                                if nrLines == 0:
                                    if self.uselineC1: self.c[ndx].lines.remove(self.lineC1[ndx])
                                    if self.uselineC2: self.c[ndx].lines.remove(self.lineC2[ndx])
                                    if self.uselineC3: self.c[ndx].lines.remove(self.lineC3[ndx])
                                    if self.uselineC4: self.c[ndx].lines.remove(self.lineC4[ndx])
                                    if self.uselineC11: self.c[ndx].lines.remove(self.lineC11[ndx])
                                    if self.uselineC12: self.c[ndx].lines.remove(self.lineC12[ndx])
                                    if ndx==common.nBL-1:
                                        common.intPlotC = 0
                                        self.uselineC1 = 0
                                        self.uselineC2 = 0
                                        self.uselineC3 = 0
                                        self.uselineC4 = 0
                                        self.uselineC11 = 0
                                        self.uselineC12 = 0
                                if nrLines == 1:
                                    self.lineC1[ndx], = self.c[ndx].plot(arrX1, arrY1, color='black', linewidth=2)
                                    self.uselineA1 = 1
                                    if ndx==common.nBL-1: common.intPlotC = 0
                                if nrLines == 2:
                                    self.lineC1[ndx], = self.c[ndx].plot(arrX1, arrY1, color='red', linewidth=2)
                                    self.lineC2[ndx], = self.c[ndx].plot(arrX2, arrY2, color='blue', linewidth=2)
                                    if ndx==common.nBL-1: common.intPlotC = 0
                                    self.uselineC1 = 1
                                    self.uselineC2 = 1
                                if nrLines == 4:
                                    self.lineC1[ndx], = self.c[ndx].plot(arrX1, arrY1, color='red')
                                    self.lineC2[ndx], = self.c[ndx].plot(arrX2, arrY2, color='blue')
                                    self.lineC3[ndx], = self.c[ndx].plot(arrX3, arrY3, color='orange')
                                    self.lineC4[ndx], = self.c[ndx].plot(arrX4, arrY4, color='green')
                                    if ndx==common.nBL-1: common.intPlotC = 0                            
                                    self.uselineC1 = 1
                                    self.uselineC2 = 1
                                    self.uselineC3 = 1
                                    self.uselineC4 = 1
                                if nrLines == 14:
                                    self.lineC1[ndx], = self.c[ndx].plot(arrX1, arrY1, color='red', linewidth=2)
                                    self.lineC2[ndx], = self.c[ndx].plot(arrX2, arrY2, color='blue', linewidth=2)
                                    self.lineC3[ndx], = self.c[ndx].plot(arrX1, arrY3, color='red', linestyle='dotted', linewidth=2)
                                    self.lineC4[ndx], = self.c[ndx].plot(arrX2, arrY4, color='blue', linestyle='dotted', linewidth=2)
                                    self.lineC11[ndx], = self.c[ndx].plot([arrX11,arrX11], [self.Ymin,self.Ymax], color='red', linestyle='--', linewidth=2)
                                    self.lineC12[ndx], = self.c[ndx].plot([arrX12,arrX12], [self.Ymin,self.Ymax], color='blue', linestyle='--', linewidth=2)
                                    if ndx==common.nBL-1: common.intPlotC = 0                            
                                    self.uselineC1 = 1
                                    self.uselineC2 = 1
                                    self.uselineC3 = 1
                                    self.uselineC4 = 1
                                    self.uselineC11 = 1
                                    self.uselineC12 = 1
                            else:
                                if nrLines == 1:
                                    self.lineC1[ndx].set_xdata(arrX1)
                                    self.lineC1[ndx].set_ydata(arrY1)
                                if nrLines == 2:
                                    self.lineC1[ndx].set_xdata(arrX1)
                                    self.lineC2[ndx].set_xdata(arrX2)
                                    self.lineC1[ndx].set_ydata(arrY1)
                                    self.lineC2[ndx].set_ydata(arrY2)
                                if nrLines == 4:
                                    self.lineC1[ndx].set_xdata(arrX1)
                                    self.lineC2[ndx].set_xdata(arrX2)
                                    self.lineC3[ndx].set_xdata(arrX3)
                                    self.lineC4[ndx].set_xdata(arrX4)
                                    self.lineC1[ndx].set_ydata(arrY1)
                                    self.lineC2[ndx].set_ydata(arrY2)
                                    self.lineC3[ndx].set_ydata(arrY3)
                                    self.lineC4[ndx].set_ydata(arrY4)
                                if nrLines == 14:
                                    self.lineC1[ndx].set_xdata(arrX1)
                                    self.lineC2[ndx].set_xdata(arrX2)
                                    self.lineC3[ndx].set_xdata(arrX1)
                                    self.lineC4[ndx].set_xdata(arrX2)
                                    self.lineC1[ndx].set_ydata(arrY1)
                                    self.lineC2[ndx].set_ydata(arrY2)
                                    self.lineC3[ndx].set_ydata(arrY3)
                                    self.lineC4[ndx].set_ydata(arrY4)
                                    self.lineC11[ndx].set_xdata([arrX11,arrX11])
                                    self.lineC11[ndx].set_ydata([self.Ymin,self.Ymax])
                                    self.lineC12[ndx].set_xdata([arrX12,arrX12])
                                    self.lineC12[ndx].set_ydata([self.Ymin,self.Ymax])
                                    
                                if common.plotType[panel] == common.plotFLUXvsOPD:
                                    self.c[ndx].set_ylim(min([min(arrY1),min(arrY2)]),1.1*max([max(arrY1),max(arrY2)]))
                                else:
                                    if common.plotType[panel] == common.plotAMPvsOPD:
                                        diff=max([max(arrX1),max(arrX2),max(arrX3),max(arrX4)]) - min([min(arrX1),min(arrX2),min(arrX3),min(arrX4)])
                                        self.c[ndx].set_xlim(min([min(arrX1),min(arrX2),min(arrX3),min(arrX4)])-diff*0.05, max([max(arrX1),max(arrX2),max(arrX3),max(arrX4)])+diff*0.05)
                                        diff=max([max(arrY1),max(arrY2),max(arrY3),max(arrY4)]) - min([min(arrY1),min(arrY2),min(arrY3),min(arrY4)])
                                        self.c[ndx].set_ylim(min([min(arrY1),min(arrY2),min(arrY3),min(arrY4)])-diff*0.1, max([max(arrY1),max(arrY2),max(arrY3),max(arrY4)])+diff*0.1)
                                    else:
                                        self.c[ndx].relim()
                                        self.c[ndx].autoscale_view()


                        #panel D
                        if panel == 3:
                            if common.intPlotD:
                                if nrLines == 0:
                                    if self.uselineD1: self.d[ndx].lines.remove(self.lineD1[ndx])
                                    if self.uselineD2: self.d[ndx].lines.remove(self.lineD2[ndx])
                                    if self.uselineD3: self.d[ndx].lines.remove(self.lineD3[ndx])
                                    if self.uselineD4: self.d[ndx].lines.remove(self.lineD4[ndx])
                                    if self.uselineD11: self.d[ndx].lines.remove(self.lineD11[ndx])
                                    if self.uselineD12: self.d[ndx].lines.remove(self.lineD12[ndx])
                                    if ndx==common.nBL-1:
                                        common.intPlotD = 0
                                        self.uselineD1 = 0
                                        self.uselineD2 = 0
                                        self.uselineD3 = 0
                                        self.uselineD4 = 0
                                        self.uselineD11 = 0
                                        self.uselineD12 = 0
                                if nrLines == 1:
                                    self.lineD1[ndx], = self.d[ndx].plot(arrX1, arrY1, color='black', linewidth=2)
                                    self.uselineD1 = 1
                                    if ndx==common.nBL-1: common.intPlotD = 0
                                if nrLines == 2:
                                    self.lineD1[ndx], = self.d[ndx].plot(arrX1, arrY1, color='red', linewidth=2)
                                    self.lineD2[ndx], = self.d[ndx].plot(arrX2, arrY2, color='blue', linewidth=2)
                                    if ndx==common.nBL-1: common.intPlotD = 0
                                    self.uselineD1 = 1
                                    self.uselineD2 = 1
                                if nrLines == 4:
                                    self.lineD1[ndx], = self.d[ndx].plot(arrX1, arrY1, color='red')
                                    self.lineD2[ndx], = self.d[ndx].plot(arrX2, arrY2, color='blue')
                                    self.lineD3[ndx], = self.d[ndx].plot(arrX3, arrY3, color='orange')
                                    self.lineD4[ndx], = self.d[ndx].plot(arrX4, arrY4, color='green')
                                    if ndx==common.nBL-1: common.intPlotD = 0                            
                                    self.uselineD1 = 1
                                    self.uselineD2 = 1
                                    self.uselineD3 = 1
                                    self.uselineD4 = 1
                                if nrLines == 14:
                                    self.lineD1[ndx], = self.d[ndx].plot(arrX1, arrY1, color='red', linewidth=2)
                                    self.lineD2[ndx], = self.d[ndx].plot(arrX2, arrY2, color='blue', linewidth=2)
                                    self.lineD3[ndx], = self.d[ndx].plot(arrX1, arrY3, color='red', linestyle='dotted', linewidth=2)
                                    self.lineD4[ndx], = self.d[ndx].plot(arrX2, arrY4, color='blue', linestyle='dotted', linewidth=2)
                                    self.lineD11[ndx], = self.d[ndx].plot([arrX11,arrX11], [self.Ymin,self.Ymax], color='red', linestyle='--', linewidth=2)
                                    self.lineD12[ndx], = self.d[ndx].plot([arrX12,arrX12], [self.Ymin,self.Ymax], color='blue', linestyle='--', linewidth=2)
                                    if ndx==common.nBL-1: common.intPlotD = 0                            
                                    self.uselineD1 = 1
                                    self.uselineD2 = 1
                                    self.uselineD3 = 1
                                    self.uselineD4 = 1
                                    self.uselineD11 = 1
                                    self.uselineD12 = 1
                            else:
                                if nrLines == 1:
                                    self.lineD1[ndx].set_xdata(arrX1)
                                    self.lineD1[ndx].set_ydata(arrY1)
                                if nrLines == 2:
                                    self.lineD1[ndx].set_xdata(arrX1)
                                    self.lineD2[ndx].set_xdata(arrX2)
                                    self.lineD1[ndx].set_ydata(arrY1)
                                    self.lineD2[ndx].set_ydata(arrY2)
                                if nrLines == 4:
                                    self.lineD1[ndx].set_xdata(arrX1)
                                    self.lineD2[ndx].set_xdata(arrX2)
                                    self.lineD3[ndx].set_xdata(arrX3)
                                    self.lineD4[ndx].set_xdata(arrX4)
                                    self.lineD1[ndx].set_ydata(arrY1)
                                    self.lineD2[ndx].set_ydata(arrY2)
                                    self.lineD3[ndx].set_ydata(arrY3)
                                    self.lineD4[ndx].set_ydata(arrY4)
                                    self.d[ndx].relim()
                                    self.d[ndx].autoscale_view()
                                if nrLines == 14:
                                    self.lineD1[ndx].set_xdata(arrX1)
                                    self.lineD2[ndx].set_xdata(arrX2)
                                    self.lineD3[ndx].set_xdata(arrX1)
                                    self.lineD4[ndx].set_xdata(arrX2)
                                    self.lineD1[ndx].set_ydata(arrY1)
                                    self.lineD2[ndx].set_ydata(arrY2)
                                    self.lineD3[ndx].set_ydata(arrY3)
                                    self.lineD4[ndx].set_ydata(arrY4)
                                    self.lineD11[ndx].set_xdata([arrX11,arrX11])
                                    self.lineD11[ndx].set_ydata([self.Ymin,self.Ymax])
                                    self.lineD12[ndx].set_xdata([arrX12,arrX12])
                                    self.lineD12[ndx].set_ydata([self.Ymin,self.Ymax])

                                if common.plotType[panel] == common.plotFLUXvsOPD:
                                    self.d[ndx].set_ylim(min([min(arrY1),min(arrY2)]),1.1*max([max(arrY1),max(arrY2)]))
                                else:
                                    if common.plotType[panel] == common.plotAMPvsOPD:
                                        diff=max([max(arrX1),max(arrX2),max(arrX3),max(arrX4)]) - min([min(arrX1),min(arrX2),min(arrX3),min(arrX4)])
                                        self.d[ndx].set_xlim(min([min(arrX1),min(arrX2),min(arrX3),min(arrX4)])-diff*0.05, max([max(arrX1),max(arrX2),max(arrX3),max(arrX4)])+diff*0.05)
                                        diff=max([max(arrY1),max(arrY2),max(arrY3),max(arrY4)]) - min([min(arrY1),min(arrY2),min(arrY3),min(arrY4)])
                                        self.d[ndx].set_ylim(min([min(arrY1),min(arrY2),min(arrY3),min(arrY4)])-diff*0.1, max([max(arrY1),max(arrY2),max(arrY3),max(arrY4)])+diff*0.1)
                                    else:
                                        self.d[ndx].relim()
                                        self.d[ndx].autoscale_view()


            self.canvas.draw()   # redraw the canvas
            time.sleep(.3)

        common.dataReadyFLUXvsOPD = 0
        common.dataReadyPHIvsOPD = 0
        common.dataReadyAMPvsOPD = 0
        common.dataReadyFLUXvsT = 0
        common.dataReadyPHIvsT = 0
        common.dataReadyDELAYvsT = 0
        common.dataReadyFTNUMvsT = 0
        common.dataReadyFTOFFSETSvsT = 0
        common.dataReadyFTSTATEvsT = 0
        common.dataReadyAMPvsFTOFFS = 0

        return True
